using System;
using System.Collections;
using System.IO;
using System.Threading;
using System.Collections.Generic;

class Program
{
    static readonly DateTime horaSorteo = new DateTime(2006, 12, 27, 21, 0, 0);
    static readonly Random rnd = new Random(DateTime.Now.Millisecond);

    static void Main(string[] args)
    {
        List<Participante> participantes = new List<Participante>();

        Console.WriteLine("\n");
        using (StreamReader reader = new StreamReader("sorteo.txt"))
        {
            string line;
            int contador = 0;
            while ((line = reader.ReadLine()) != null)
            {
                participantes.Add(new Participante(line.Split(',')[0], line.Split(',')[1]));
                Console.WriteLine(contador++ + " -> " + participantes[participantes.Count - 1]);
                rnd.Next();
            }
        }
        Console.Write("\n\n[{0}] Inicio del sorteo...\n\n", DateTime.Now.ToLongTimeString());

        int intento = 1;
        while (true)
        {
            // Seguir generando nmeros aleatorios
            rnd.Next();
            Thread.Sleep(1000);
            
            // Mostrar candidatos desde antes de x segundos
            if (DateTime.Now.CompareTo(horaSorteo.AddSeconds(-1.1 * participantes.Count)) > 0)
            {
                Console.WriteLine("[{0}] Intento: {1}\tNroEscogido:{2}", 
                        DateTime.Now.ToLongTimeString(), 
                        intento++,
                        ObtenerGanador(participantes.Count));
            }
            if (DateTime.Now.CompareTo(horaSorteo) >= 0)
            {
                int ganador = ObtenerGanador(participantes.Count);
                Console.WriteLine("\n[{0}] El ganador es el nmero {1}, con {2}", 
                    DateTime.Now.ToLongTimeString(),
                    ganador, 
                    participantes[ganador]);
                Console.Title = participantes[ganador].ToString();
                break;
            }            
        }
    }
    public static int ObtenerGanador(int numeroParticipantes)
    {
        int ganador = 0;
        
        for (int i = 0; i < numeroParticipantes; i++)
            ganador += rnd.Next(0, numeroParticipantes);

        return ganador % numeroParticipantes;
    }
}

class Participante
{
    private string Nombre, Email;
    public Participante(string nombre, string email)
    {
        Nombre = nombre;
        Email = email;
    }
    public override string ToString()
    {
        return string.Format("Nombre: {0}\t--***--\tEmail: {1}",
            Nombre,
            System.Text.RegularExpressions.Regex.Replace(Email, @"@[^.]+", "@*****"));
    }
}